Index: uspace/drv/bus/usb/xhci/trb_ring.c
===================================================================
--- uspace/drv/bus/usb/xhci/trb_ring.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/xhci/trb_ring.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,495 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <assert.h>
+#include <ddi.h>
+#include <as.h>
+#include <align.h>
+#include <libarch/barrier.h>
+#include <usb/debug.h>
+#include "hw_struct/trb.h"
+#include "trb_ring.h"
+
+/**
+ * A structure representing a segment of a TRB ring.
+ */
+
+#define SEGMENT_FOOTER_SIZE (sizeof(link_t) + sizeof(uintptr_t))
+
+#define SEGMENT_TRB_COUNT ((PAGE_SIZE - SEGMENT_FOOTER_SIZE) / sizeof(xhci_trb_t))
+#define SEGMENT_TRB_USEFUL_COUNT (SEGMENT_TRB_COUNT - 1)
+
+struct trb_segment {
+	xhci_trb_t trb_storage [SEGMENT_TRB_COUNT];
+
+	link_t segments_link;
+	uintptr_t phys;
+} __attribute__((aligned(PAGE_SIZE)));
+
+static_assert(sizeof(trb_segment_t) == PAGE_SIZE);
+
+
+/**
+ * Get the first TRB of a segment.
+ */
+static inline xhci_trb_t *segment_begin(trb_segment_t *segment)
+{
+	return segment->trb_storage;
+}
+
+/**
+ * Get the one-past-end TRB of a segment.
+ */
+static inline xhci_trb_t *segment_end(trb_segment_t *segment)
+{
+	return segment_begin(segment) + SEGMENT_TRB_COUNT;
+}
+
+/**
+ * Return a first segment of a list of segments.
+ */
+static inline trb_segment_t *get_first_segment(list_t *segments)
+{
+	return list_get_instance(list_first(segments), trb_segment_t, segments_link);
+
+}
+
+/**
+ * Allocate and initialize new segment.
+ *
+ * TODO: When the HC supports 64-bit addressing, there's no need to restrict
+ * to DMAMEM_4GiB.
+ */
+static int trb_segment_alloc(trb_segment_t **segment)
+{
+	dma_buffer_t dbuf;
+
+	const int err = dma_buffer_alloc(&dbuf, PAGE_SIZE);
+	if (err)
+		return err;
+
+	*segment = dbuf.virt;
+	memset(*segment, 0, PAGE_SIZE);
+	(*segment)->phys = dbuf.phys;
+	usb_log_debug("Allocated new ring segment.");
+	return EOK;
+}
+
+static void trb_segment_free(trb_segment_t *segment)
+{
+	dma_buffer_t dbuf = { .virt = segment, .phys = segment->phys };
+	dma_buffer_free(&dbuf);
+}
+
+/**
+ * Initializes the ring with one segment.
+ *
+ * @param[in] initial_size A number of free slots on the ring, 0 leaves the
+ * choice on a reasonable default (one page-sized segment).
+ */
+int xhci_trb_ring_init(xhci_trb_ring_t *ring, size_t initial_size)
+{
+	int err;
+	if (initial_size == 0)
+		initial_size = SEGMENT_TRB_USEFUL_COUNT;
+
+	list_initialize(&ring->segments);
+	size_t segment_count = (initial_size + SEGMENT_TRB_USEFUL_COUNT - 1)
+		/ SEGMENT_TRB_USEFUL_COUNT;
+
+	for (size_t i = 0; i < segment_count; ++i) {
+		struct trb_segment *segment;
+		if ((err = trb_segment_alloc(&segment)) != EOK)
+			return err;
+
+		list_append(&segment->segments_link, &ring->segments);
+		ring->segment_count = i + 1;
+	}
+
+	trb_segment_t * const segment = get_first_segment(&ring->segments);
+	xhci_trb_t *last = segment_end(segment) - 1;
+	xhci_trb_link_fill(last, segment->phys);
+	TRB_LINK_SET_TC(*last, true);
+
+	ring->enqueue_segment = segment;
+	ring->enqueue_trb = segment_begin(segment);
+	ring->dequeue = segment->phys;
+	ring->pcs = 1;
+
+	fibril_mutex_initialize(&ring->guard);
+
+	return EOK;
+}
+
+/**
+ * Free all segments inside the ring.
+ */
+void xhci_trb_ring_fini(xhci_trb_ring_t *ring)
+{
+	assert(ring);
+
+	list_foreach_safe(ring->segments, cur, next) {
+		trb_segment_t *segment =
+		    list_get_instance(cur, trb_segment_t, segments_link);
+		trb_segment_free(segment);
+	}
+}
+
+/**
+ * When the enqueue pointer targets a Link TRB, resolve it.
+ *
+ * Relies on segments being in the segment list in linked order.
+ *
+ * According to section 4.9.2.2, figure 16, the link TRBs cannot be chained, so
+ * it shall not be called in cycle, nor have an inner cycle.
+ */
+static void trb_ring_resolve_link(xhci_trb_ring_t *ring)
+{
+	link_t *next_segment =
+	    list_next(&ring->enqueue_segment->segments_link, &ring->segments);
+	if (!next_segment)
+		next_segment = list_first(&ring->segments);
+	assert(next_segment);
+
+	ring->enqueue_segment =
+	    list_get_instance(next_segment, trb_segment_t, segments_link);
+	ring->enqueue_trb = segment_begin(ring->enqueue_segment);
+}
+
+/**
+ * Get the physical address of the enqueue pointer.
+ */
+static uintptr_t trb_ring_enqueue_phys(xhci_trb_ring_t *ring)
+{
+	uintptr_t trb_id = ring->enqueue_trb - segment_begin(ring->enqueue_segment);
+	return ring->enqueue_segment->phys + trb_id * sizeof(xhci_trb_t);
+}
+
+/**
+ * Decides whether the TRB will trigger an interrupt after being processed.
+ */
+static bool trb_generates_interrupt(xhci_trb_t *trb)
+{
+	return TRB_TYPE(*trb) >= XHCI_TRB_TYPE_ENABLE_SLOT_CMD
+		|| TRB_IOC(*trb);
+}
+
+/**
+ * Enqueue TD composed of TRBs.
+ *
+ * This will copy specified number of TRBs chained together into the ring. The
+ * cycle flag in TRBs may be changed.
+ *
+ * The copied TRBs must be contiguous in memory, and must not contain Link TRBs.
+ *
+ * We cannot avoid the copying, because the TRB in ring should be updated
+ * atomically.
+ *
+ * @param first_trb the first TRB
+ * @param trbs number of TRBS to enqueue
+ * @param phys returns address of the last TRB enqueued
+ * @return EOK on success,
+ *         EAGAIN when the ring is too full to fit all TRBs (temporary)
+ */
+int xhci_trb_ring_enqueue_multiple(xhci_trb_ring_t *ring, xhci_trb_t *first_trb,
+	size_t trbs, uintptr_t *phys)
+{
+	int err;
+	assert(trbs > 0);
+	fibril_mutex_lock(&ring->guard);
+
+	xhci_trb_t * const saved_enqueue_trb = ring->enqueue_trb;
+	trb_segment_t * const saved_enqueue_segment = ring->enqueue_segment;
+	if (phys)
+		*phys = (uintptr_t)NULL;
+
+	/*
+	 * First, dry run and advance the enqueue pointer to see if the ring would
+	 * be full anytime during the transaction.
+	 */
+	xhci_trb_t *trb = first_trb;
+	for (size_t i = 0; i < trbs; ++i, ++trb) {
+		if (phys && trb_generates_interrupt(trb)) {
+			if (*phys) {
+				err = ENOTSUP;
+				goto err;
+			}
+			*phys = trb_ring_enqueue_phys(ring);
+		}
+
+		ring->enqueue_trb++;
+
+		if (TRB_TYPE(*ring->enqueue_trb) == XHCI_TRB_TYPE_LINK)
+			trb_ring_resolve_link(ring);
+
+		if (trb_ring_enqueue_phys(ring) == ring->dequeue) {
+			err = EAGAIN;
+			goto err;
+		}
+	}
+
+	ring->enqueue_segment = saved_enqueue_segment;
+	ring->enqueue_trb = saved_enqueue_trb;
+
+	/*
+	 * Now, copy the TRBs without further checking.
+	 */
+	trb = first_trb;
+	for (size_t i = 0; i < trbs; ++i, ++trb) {
+		TRB_SET_CYCLE(*trb, ring->pcs);
+		xhci_trb_copy_to_pio(ring->enqueue_trb, trb);
+
+		usb_log_debug2("TRB ring(%p): Enqueued TRB %p", ring, trb);
+		ring->enqueue_trb++;
+
+		if (TRB_TYPE(*ring->enqueue_trb) == XHCI_TRB_TYPE_LINK) {
+			TRB_SET_CYCLE(*ring->enqueue_trb, ring->pcs);
+
+			if (TRB_LINK_TC(*ring->enqueue_trb)) {
+				ring->pcs = !ring->pcs;
+				usb_log_debug("TRB ring(%p): PCS toggled", ring);
+			}
+
+			trb_ring_resolve_link(ring);
+		}
+	}
+
+	fibril_mutex_unlock(&ring->guard);
+	return EOK;
+
+err:
+	ring->enqueue_segment = saved_enqueue_segment;
+	ring->enqueue_trb = saved_enqueue_trb;
+	fibril_mutex_unlock(&ring->guard);
+	return err;
+}
+
+/**
+ * Enqueue TD composed of a single TRB. See: `xhci_trb_ring_enqueue_multiple`
+ */
+int xhci_trb_ring_enqueue(xhci_trb_ring_t *ring, xhci_trb_t *td, uintptr_t *phys)
+{
+	return xhci_trb_ring_enqueue_multiple(ring, td, 1, phys);
+}
+
+void xhci_trb_ring_reset_dequeue_state(xhci_trb_ring_t *ring, uintptr_t *addr)
+{
+	assert(ring);
+
+	ring->dequeue = trb_ring_enqueue_phys(ring);
+
+	if (addr)
+		*addr = ring->dequeue | ring->pcs;
+}
+
+/**
+ * Initializes an event ring.
+ *
+ * @param[in] initial_size A number of free slots on the ring, 0 leaves the
+ * choice on a reasonable default (one page-sized segment).
+ */
+int xhci_event_ring_init(xhci_event_ring_t *ring, size_t initial_size)
+{
+	int err;
+	if (initial_size == 0)
+		initial_size = SEGMENT_TRB_COUNT;
+
+	list_initialize(&ring->segments);
+
+	size_t segment_count = (initial_size + SEGMENT_TRB_COUNT - 1) / SEGMENT_TRB_COUNT;
+	size_t erst_size = segment_count * sizeof(xhci_erst_entry_t);
+
+	if (dma_buffer_alloc(&ring->erst, erst_size)) {
+		xhci_event_ring_fini(ring);
+		return ENOMEM;
+	}
+
+	xhci_erst_entry_t *erst = ring->erst.virt;
+	memset(erst, 0, erst_size);
+
+	for (size_t i = 0; i < segment_count; i++) {
+		trb_segment_t *segment;
+		if ((err = trb_segment_alloc(&segment)) != EOK) {
+			xhci_event_ring_fini(ring);
+			return err;
+		}
+
+		list_append(&segment->segments_link, &ring->segments);
+		ring->segment_count = i + 1;
+		xhci_fill_erst_entry(&erst[i], segment->phys, SEGMENT_TRB_COUNT);
+	}
+
+	trb_segment_t * const segment = get_first_segment(&ring->segments);
+	ring->dequeue_segment = segment;
+	ring->dequeue_trb = segment_begin(segment);
+	ring->dequeue_ptr = segment->phys;
+	ring->ccs = 1;
+
+	fibril_mutex_initialize(&ring->guard);
+
+	usb_log_debug("Initialized event ring.");
+	return EOK;
+}
+
+void xhci_event_ring_fini(xhci_event_ring_t *ring)
+{
+	list_foreach_safe(ring->segments, cur, next) {
+		trb_segment_t *segment = list_get_instance(cur, trb_segment_t, segments_link);
+		trb_segment_free(segment);
+	}
+
+	dma_buffer_free(&ring->erst);
+}
+
+/**
+ * Get the physical address of the dequeue pointer.
+ */
+static uintptr_t event_ring_dequeue_phys(xhci_event_ring_t *ring)
+{
+	uintptr_t trb_id = ring->dequeue_trb - segment_begin(ring->dequeue_segment);
+	return ring->dequeue_segment->phys + trb_id * sizeof(xhci_trb_t);
+}
+
+/**
+ * Fill the event with next valid event from the ring.
+ *
+ * @param event pointer to event to be overwritten
+ * @return EOK on success,
+ *         ENOENT when the ring is empty
+ */
+int xhci_event_ring_dequeue(xhci_event_ring_t *ring, xhci_trb_t *event)
+{
+	fibril_mutex_lock(&ring->guard);
+
+	/**
+	 * The ERDP reported to the HC is a half-phase off the one we need to
+	 * maintain. Therefore, we keep it extra.
+	 */
+	ring->dequeue_ptr = event_ring_dequeue_phys(ring);
+
+	if (TRB_CYCLE(*ring->dequeue_trb) != ring->ccs) {
+		fibril_mutex_unlock(&ring->guard);
+		return ENOENT; /* The ring is empty. */
+	}
+
+	/* Do not reorder the Cycle bit reading with memcpy */
+	read_barrier();
+
+	memcpy(event, ring->dequeue_trb, sizeof(xhci_trb_t));
+
+	ring->dequeue_trb++;
+	const unsigned index = ring->dequeue_trb - segment_begin(ring->dequeue_segment);
+
+	/* Wrapping around segment boundary */
+	if (index >= SEGMENT_TRB_COUNT) {
+		link_t *next_segment =
+		    list_next(&ring->dequeue_segment->segments_link, &ring->segments);
+
+		/* Wrapping around table boundary */
+		if (!next_segment) {
+			next_segment = list_first(&ring->segments);
+			ring->ccs = !ring->ccs;
+		}
+
+		ring->dequeue_segment =
+		    list_get_instance(next_segment, trb_segment_t, segments_link);
+		ring->dequeue_trb = segment_begin(ring->dequeue_segment);
+	}
+
+	fibril_mutex_unlock(&ring->guard);
+	return EOK;
+}
+
+void xhci_sw_ring_init(xhci_sw_ring_t *ring, size_t size)
+{
+	ring->begin = calloc(size, sizeof(xhci_trb_t));
+	ring->end = ring->begin + size;
+
+	ring->enqueue = ring->dequeue = ring->begin;
+
+	fibril_mutex_initialize(&ring->guard);
+	fibril_condvar_initialize(&ring->enqueued_cv);
+	fibril_condvar_initialize(&ring->dequeued_cv);
+
+	ring->running = true;
+}
+
+int xhci_sw_ring_enqueue(xhci_sw_ring_t *ring, xhci_trb_t *trb)
+{
+	assert(ring);
+	assert(trb);
+
+	fibril_mutex_lock(&ring->guard);
+	while (ring->running && TRB_CYCLE(*ring->enqueue))
+		fibril_condvar_wait(&ring->dequeued_cv, &ring->guard);
+
+	*ring->enqueue = *trb;
+	TRB_SET_CYCLE(*ring->enqueue, 1);
+	if (++ring->enqueue == ring->end)
+		ring->enqueue = ring->begin;
+	fibril_condvar_signal(&ring->enqueued_cv);
+	fibril_mutex_unlock(&ring->guard);
+
+	return ring->running ? EOK : EINTR;
+}
+
+int xhci_sw_ring_dequeue(xhci_sw_ring_t *ring, xhci_trb_t *trb)
+{
+	assert(ring);
+	assert(trb);
+
+	fibril_mutex_lock(&ring->guard);
+	while (ring->running && !TRB_CYCLE(*ring->dequeue))
+		fibril_condvar_wait(&ring->enqueued_cv, &ring->guard);
+
+	*trb = *ring->dequeue;
+	TRB_SET_CYCLE(*ring->dequeue, 0);
+	if (++ring->dequeue == ring->end)
+		ring->dequeue = ring->begin;
+	fibril_condvar_signal(&ring->dequeued_cv);
+	fibril_mutex_unlock(&ring->guard);
+
+	return ring->running ? EOK : EINTR;
+}
+
+void xhci_sw_ring_stop(xhci_sw_ring_t *ring)
+{
+	ring->running = false;
+	fibril_condvar_broadcast(&ring->enqueued_cv);
+	fibril_condvar_broadcast(&ring->dequeued_cv);
+}
+
+void xhci_sw_ring_fini(xhci_sw_ring_t *ring)
+{
+	free(ring->begin);
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/xhci/trb_ring.h
===================================================================
--- uspace/drv/bus/usb/xhci/trb_ring.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/xhci/trb_ring.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,139 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbxhci
+ * @{
+ */
+/** @file
+ * TRB Ring is a data structure for communication between HC and software.
+ *
+ * Despite this description, it is not used as an hardware structure - all but
+ * the Event ring is used as buffer of the TRBs itself, linked by Link TRB to
+ * form a (possibly multi-segment) circular buffer.
+ *
+ * This data structure abstracts this behavior.
+ */
+
+#ifndef XHCI_TRB_RING_H
+#define XHCI_TRB_RING_H
+
+#include <adt/list.h>
+#include <fibril_synch.h>
+#include <libarch/config.h>
+#include <usb/host/dma_buffer.h>
+
+typedef struct trb_segment trb_segment_t;
+typedef struct xhci_hc xhci_hc_t;
+typedef struct xhci_trb xhci_trb_t;
+typedef struct xhci_erst_entry xhci_erst_entry_t;
+
+/**
+ * A TRB ring of which the software is a producer - command / transfer.
+ */
+typedef struct xhci_trb_ring {
+	list_t segments;                /* List of assigned segments */
+	int segment_count;              /* Number of segments assigned */
+
+	/*
+	 * As the link TRBs connect physical addresses, we need to keep track of
+	 * active segment in virtual memory. The enqueue ptr should always belong
+	 * to the enqueue segment.
+	 */
+	trb_segment_t *enqueue_segment;
+	xhci_trb_t *enqueue_trb;
+
+	uintptr_t dequeue;              /* Last reported position of the dequeue pointer */
+	bool pcs;                       /* Producer Cycle State: section 4.9.2 */
+
+	fibril_mutex_t guard;
+} xhci_trb_ring_t;
+
+extern int xhci_trb_ring_init(xhci_trb_ring_t *, size_t);
+extern void xhci_trb_ring_fini(xhci_trb_ring_t *);
+extern int xhci_trb_ring_enqueue(xhci_trb_ring_t *, xhci_trb_t *, uintptr_t *);
+extern int xhci_trb_ring_enqueue_multiple(xhci_trb_ring_t *, xhci_trb_t *, size_t, uintptr_t *);
+
+extern void xhci_trb_ring_reset_dequeue_state(xhci_trb_ring_t *ring, uintptr_t *addr);
+
+/**
+ * When an event is received by the upper layer, it needs to update the dequeue
+ * pointer inside the ring. Otherwise, the ring will soon show up as full.
+ */
+static inline void xhci_trb_ring_update_dequeue(xhci_trb_ring_t *ring, uintptr_t phys) {
+	ring->dequeue = phys;
+}
+
+/**
+ * A TRB ring of which the software is a consumer (event rings).
+ */
+typedef struct xhci_event_ring {
+	list_t segments;                /* List of assigned segments */
+	int segment_count;              /* Number of segments assigned */
+
+	trb_segment_t *dequeue_segment; /* Current segment of the dequeue ptr */
+	xhci_trb_t *dequeue_trb;        /* Next TRB to be processed */
+	uintptr_t dequeue_ptr;          /* Physical address of the ERDP to be reported to the HC */
+
+	dma_buffer_t erst;              /* ERST given to the HC */
+
+	bool ccs;                       /* Consumer Cycle State: section 4.9.2 */
+
+	fibril_mutex_t guard;
+} xhci_event_ring_t;
+
+extern int xhci_event_ring_init(xhci_event_ring_t *, size_t);
+extern void xhci_event_ring_fini(xhci_event_ring_t *);
+extern int xhci_event_ring_dequeue(xhci_event_ring_t *, xhci_trb_t *);
+
+/**
+ * A TRB ring of which the software is both consumer and provider.
+ */
+typedef struct xhci_sw_ring {
+	xhci_trb_t *begin, *end;
+	xhci_trb_t *enqueue, *dequeue;
+
+	fibril_mutex_t guard;
+	fibril_condvar_t enqueued_cv, dequeued_cv;
+
+	bool running;
+} xhci_sw_ring_t;
+
+extern void xhci_sw_ring_init(xhci_sw_ring_t *, size_t);
+
+/* Both may block if the ring is full/empty. */
+extern int xhci_sw_ring_enqueue(xhci_sw_ring_t *, xhci_trb_t *);
+extern int xhci_sw_ring_dequeue(xhci_sw_ring_t *, xhci_trb_t *);
+
+extern void xhci_sw_ring_stop(xhci_sw_ring_t *);
+extern void xhci_sw_ring_fini(xhci_sw_ring_t *);
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/xhci/xhci.ma
===================================================================
--- uspace/drv/bus/usb/xhci/xhci.ma	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/xhci/xhci.ma	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,2 @@
+20 usb/host=xhci
+10 pci/class=0c&subclass=03&progif=30
Index: uspace/drv/hid/usbhid/blink1/blink1.c
===================================================================
--- uspace/drv/hid/usbhid/blink1/blink1.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/blink1/blink1.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -64,5 +64,5 @@
 	usb_blink1_t *blink1_dev = (usb_blink1_t *) ddf_fun_data_get(fun);
 	if (blink1_dev == NULL) {
-		usb_log_debug("Missing parameters.\n");
+		usb_log_debug("Missing parameters.");
 		return EINVAL;
 	}
@@ -105,5 +105,5 @@
 	    fun_exposed, HID_BLINK1_FUN_NAME);
 	if (fun == NULL) {
-		usb_log_error("Could not create DDF function node `%s'.\n",
+		usb_log_error("Could not create DDF function node `%s'.",
 		    HID_BLINK1_FUN_NAME);
 		return ENOMEM;
@@ -123,5 +123,5 @@
 	errno_t rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		usb_log_error("Could not bind DDF function `%s': %s.\n",
+		usb_log_error("Could not bind DDF function `%s': %s.",
 		    ddf_fun_get_name(fun), str_error(rc));
 		ddf_fun_destroy(fun);
@@ -131,5 +131,5 @@
 	rc = ddf_fun_add_to_category(fun, HID_BLINK1_CATEGORY);
 	if (rc != EOK) {
-		usb_log_error("Could not add DDF function to category %s: %s.\n",
+		usb_log_error("Could not add DDF function to category %s: %s.",
 		    HID_BLINK1_CATEGORY, str_error(rc));
 		
Index: uspace/drv/hid/usbhid/generic/hiddev.c
===================================================================
--- uspace/drv/hid/usbhid/generic/hiddev.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/hid/usbhid/generic/hiddev.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -96,5 +96,5 @@
 	const usb_hid_dev_t *hid_dev = fun_hid_dev(fun);
 
-	usb_log_debug2("hid_dev: %p, Max input report size (%zu).\n",
+	usb_log_debug2("hid_dev: %p, Max input report size (%zu).",
 	    hid_dev, hid_dev->max_input_report_size);
 
@@ -105,5 +105,5 @@
     size_t size, size_t *act_size, int *event_nr, unsigned int flags)
 {
-	usb_log_debug2("Generic HID: Get event.\n");
+	usb_log_debug2("Generic HID: Get event.");
 
 	if (buffer == NULL || act_size == NULL || event_nr == NULL) {
@@ -115,5 +115,5 @@
 
 	if (hid_dev->input_report_size > size) {
-		usb_log_debug("input_report_size > size (%zu, %zu)\n",
+		usb_log_debug("input_report_size > size (%zu, %zu)",
 		    hid_dev->input_report_size, size);
 		return EINVAL;	// TODO: other error code
@@ -126,5 +126,5 @@
 	*event_nr = usb_hid_report_number(hid_dev);
 
-	usb_log_debug2("OK\n");
+	usb_log_debug2("OK");
 
 	return EOK;
@@ -133,9 +133,9 @@
 static size_t usb_generic_get_report_descriptor_length(ddf_fun_t *fun)
 {
-	usb_log_debug("Generic HID: Get report descriptor length.\n");
-
-	const usb_hid_dev_t *hid_dev = fun_hid_dev(fun);
-
-	usb_log_debug2("hid_dev->report_desc_size = %zu\n",
+	usb_log_debug("Generic HID: Get report descriptor length.");
+
+	const usb_hid_dev_t *hid_dev = fun_hid_dev(fun);
+
+	usb_log_debug2("hid_dev->report_desc_size = %zu",
 	    hid_dev->report_desc_size);
 
@@ -146,5 +146,5 @@
     size_t size, size_t *actual_size)
 {
-	usb_log_debug2("Generic HID: Get report descriptor.\n");
+	usb_log_debug2("Generic HID: Get report descriptor.");
 
 	const usb_hid_dev_t *hid_dev = fun_hid_dev(fun);
@@ -162,5 +162,5 @@
 static errno_t usb_generic_hid_client_connected(ddf_fun_t *fun)
 {
-	usb_log_debug("Generic HID: Client connected.\n");
+	usb_log_debug("Generic HID: Client connected.");
 	return EOK;
 }
@@ -173,8 +173,8 @@
 
 	if (ddf_fun_unbind(fun) != EOK) {
-		usb_log_error("Failed to unbind generic hid fun.\n");
+		usb_log_error("Failed to unbind generic hid fun.");
 		return;
 	}
-	usb_log_debug2("%s unbound.\n", ddf_fun_get_name(fun));
+	usb_log_debug2("%s unbound.", ddf_fun_get_name(fun));
 	ddf_fun_destroy(fun);
 }
@@ -189,9 +189,9 @@
 
 	/* Create the exposed function. */
-	usb_log_debug("Creating DDF function %s...\n", HID_GENERIC_FUN_NAME);
+	usb_log_debug("Creating DDF function %s...", HID_GENERIC_FUN_NAME);
 	ddf_fun_t *fun = usb_device_ddf_fun_create(hid_dev->usb_dev,
 	    fun_exposed, HID_GENERIC_FUN_NAME);
 	if (fun == NULL) {
-		usb_log_error("Could not create DDF function node.\n");
+		usb_log_error("Could not create DDF function node.");
 		return ENOMEM;
 	}
@@ -204,5 +204,5 @@
 	errno_t rc = ddf_fun_bind(fun);
 	if (rc != EOK) {
-		usb_log_error("Could not bind DDF function: %s.\n",
+		usb_log_error("Could not bind DDF function: %s.",
 		    str_error(rc));
 		ddf_fun_destroy(fun);
@@ -210,5 +210,5 @@
 	}
 
-	usb_log_debug("HID function created. Handle: %" PRIun "\n",
+	usb_log_debug("HID function created. Handle: %" PRIun "",
 	    ddf_fun_get_handle(fun));
 	*data = fun;
@@ -219,4 +219,5 @@
 bool usb_generic_hid_polling_callback(usb_hid_dev_t *hid_dev, void *data)
 {
+	/* Continue polling until the device is about to be removed. */
 	return true;
 }
